require 'sqlite3'

PRINT_QUERIES = ENV['PRINT_QUERIES'] == 'true'
ROOT_FOLDER = File.join(File.dirname(__FILE__), '..')

module WORMY
  class DBConnection
    attr_accessor :seed_file, :db_file

    def self.open(db_file_name)
      @db = SQLite3::Database.new(db_file_name)
      @db.results_as_hash = true
      @db.type_translation = true

      @db
    end

    def self.reset
      commands = [
        "rm '#{DB_FILE}'",
        "cat '#{SQL_FILE}' | sqlite3 '#{DB_FILE}'"
      ]

      commands.each { |command| `#{command}` }
      DBConnection.open(DB_FILE)
    end

    def self.instance
      reset if @db.nil?

      @db
    end

    def self.execute(*args)
      print_query(*args)
      instance.execute(*args)
    end

    def self.execute2(*args)
      print_query(*args)
      instance.execute2(*args)
    end

    def self.last_insert_row_id
      instance.last_insert_row_id
    end


    def configure(seed_file, db_file)
      @seed_file = seed_file
      @db_file = db_file
    end

    private

    def self.print_query(query, *interpolation_args)
      return unless PRINT_QUERIES

      puts '--------------------'
      puts query
      unless interpolation_args.empty?
        puts "interpolate: #{interpolation_args.inspect}"
      end
      puts '--------------------'
    end
  end
end
